#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "clocks/clocks.h"

#define NP 2003
  const int np = NP;
  const int nr = NP*NP;
  const double a1=1.0;
  const double a2=3.0;
  const double a3=3.0;
  const double teps=0.1;
  double tmin=-1.0;

  double ran1(int);
  double ran2(int);
  double tstran(double *a,int n, int np, 
                double tcp, double tmin);
  double tstsol(double *a, double *b, double *x,
      double *y, double *v, int *indx, 
      int n, int np, double tcp, double tmin);
  void lubksb(double *a, int n, int np, int *indx, 
                           double *b);
  int ludcmp(double *a, int n, int np, int *indx,
                           double *d, double *vv);
  double tstsor(double *a, int n, double tcp, double tmin);
  void sort(double *ra, int n);
  double dettmi(void);
  double cptime(void);
  double meatcp(double tmin);
  int main()
  {
    double tcp=0,an;

    double *a = malloc(sizeof(double)*np*np);
    double *b = malloc(sizeof(double)*np*np);
    double *x = malloc(sizeof(double)*np);
    double *y = malloc(sizeof(double)*np);
    double *v = malloc(sizeof(double)*np);
    double *aa = malloc(sizeof(double)*nr);
    int *indx = malloc(sizeof(int)*np);
    int n;
    double dummy = ran1(-1);
    dummy = ran2(-1);
    n = np;
    printf("THIS IS PROGRAM WEPS: MEASURES CPU SPEED\n");
    printf("C VERSION\n");
    while (1)
    {
      printf("ENTER ORDER OF MATRICES TO BE USED, 0 TO STOP\n");
      int items = scanf("%d",&n);
      an = n;
      if ( n == 0 || items == 0)
        break;
      if (n > np || n <= 1 ) 
      {
        printf("ORDER MUST BE IN THE RANGE 2..%d\n",np);
        continue;
      }
      if (tmin <= 0)
      {
        tmin = dettmi();
        tcp = meatcp(tmin);
        //tmin = Math.max(Math.max(100.0*tcp,tmin),1.0);
        tmin=fmax(fmax(100*tcp,tmin),1.0);
        printf("MINIMUM CPU TIME PER MEASUREMENT IS %f SEC\n",tmin);
      }
      int nsort = n*n;

      printf("NUMBER CRUNCHING ...\n");
      double t1 = tstran(a,n,np,tcp,tmin);
      double t2 = tstsol(a,b,x,y,v,indx,n,np,tcp,tmin);
      double t3 = tstsor(aa,nsort,tcp,tmin);

      char mark1=' ';
      char mark2=' ';
      char mark3=' ';
      char markh=' ';

      if (tcp > teps*t1) mark1='*';
      if (tcp > teps*t2) mark2='*';
      if (tcp > teps*t3) mark3='*';

      int inac = mark1 != ' ' || mark2 != ' ' || mark3 != ' ';
      if (inac)
        markh = '*';

      double c1 = 10*an*an;
      double c2 = 1.0/3*(an*an*an+11*an*an);
      double c3 = nsort*log((double)nsort);

      double w1 = c1/t1*0.001;
      double w2 = c2/t2*0.001;
      double w3 = c3/t3*0.001;

      printf("DECLARED ORDER OF MATRICES: %d\n",np);
      printf("ORDER OF MATRICES:          %d\n",n);
      printf("DIMENSION OF SORT ARRAY:    %d\n",nsort);

      double hw = (a1+a2+a3)/(a1/w1+a2/w2+a3/w3);


      printf("                                   ");
      printf("WEIGHT    CPUTIME");
      printf("         SPEED\n");
      printf("                                             ");
      printf("(SECONDS)");
      printf("      (KILOWEPS)\n");
      printf("\n");


      //String form = "%9d:%7.1f%12.6f%14.1f    %c%n";
      //String formh = "         :                   %14.1f    %c%n";
      printf("SUBROUTINE, # CALLS IS %9d:%7.1f%12.6f%14.1f    %c\n",n*n,a1,t1,w1,mark1);
      printf("LIN EQUATIONS OF ORDER %9d:%7.1f%12.6f%14.1f    %c\n",n,a2,t2,w2,mark2);
      printf("SORTING, # ELEMENTS IS %9d:%7.1f%12.6f%14.1f    %c\n",n*n,a3,t3,w3,mark3);
      printf("HARMONIC WEIGHTED MEAN          :                   %14.1f    %c\n",hw,mark3);

      if (inac)
        printf(" * MEANS: POSSIBLY INACCURATE\n");
        printf("\n");
        printf(" END OF THIS WEPS MEASUREMENT\n");
    }
  printf(" END OF PROGRAM WEPS\n");
  return 0;

  }
  double tstran(double *a,int n, int np, 
                double tcp, double tmin)
  {
    int loop = 0;
    double t0 = cptime();
    double dt = 0;
    double t;
    while (dt < tmin)
    {
      int i,j;
      loop++;
      for (i=0; i<n; i++)
        for (j=0; j<n; j++)
          //a[i][j] = ran1(1);
          a[i + np*j] = ran1(1);

      t = cptime();
      dt = t - t0 - loop*tcp;
    }

    t = dt/loop;
    return t;
  }
  double ran1(int idum)
  {
    static int iff=0;
    static double r[98];
    static int ix1,ix2,ix3;
    const int m1=259200,ia1=7141,ic1=54773;
    const double rm1=1.0/m1;
    const int m2=134456,ia2=8121,ic2=28411;
    const double rm2=1.0/m2;
    const int m3=243000,ia3=4561,ic3=51349;

    if (idum < 0 || iff == 0)
    {
      iff = 1;
      ix1=fabs((ic1-idum)%m1);
      ix1=(ia1*ix1+ic1) % m1;
      ix2 = ix1 % m2;
      ix1 = (ia1*ix1+ic1) % m1;
      ix3 = ix1 % m3;

      int j;
      for (j=1; j<=97; j++)
      {
        ix1 = (ia1*ix1+ic1) % m1;
        ix2 = (ia2*ix2+ic2) % m2;
        r[j] = ((double)ix1 + rm2*(double)ix2)*rm1;
      }
    }

    ix1 = (ia1*ix1+ic1) % m1;
    ix2 = (ia2*ix2+ic2) % m2;
    ix3 = (ia3*ix3+ic3) % m3;

    int j = 1+(97*ix3)/m3;
    if (j > 97 || j < 1)
    {
      printf("THIS SHOULD NOT HAPPEN !!!, ROUTINE RAN1\n");
      printf("J=%d\n",j);
      exit(1);
    }
    double x = r[j];
    r[j] = ((double)ix1+rm2*(double)ix2)*rm1;
    return x;
  }


  double ran2(int idum)
  {
    static int iy,jdum;
    static int iff=0;
    const int m=714025; 
    const int ia=1366; 
    const int ic=150889;
    const double rm=1.0/m;

    static int ir[98];
    if (idum < 0 || iff == 0)
    {
      iff = 1;
      jdum = fabs((ic-idum) % m);
      int j;
      for (j=1; j<=97; j++)
      {
        jdum = (ia*jdum+ic) % m;
        ir[j] = jdum;
      }
      jdum = (ia*jdum+ic) % m;
      iy = jdum;
    }
    int j = 1+(97*iy)/m;
    if (j > 97 || j < 1)
    {
      printf("THIS SHOULD NOT HAPPEN !!!, FUNCTION RAN2\n");
      printf("J=%d\n",j);
      exit(1);
    }
    iy = ir[j];
    double x = iy*rm;
    jdum = (ia*jdum+ic) % m;
    ir[j] = jdum;
    return x;
  }

  double tstsol(double *a, double *b, double *x,
      double *y, double *v, int *indx, 
      int n, int np, double tcp, double tmin)
  {
    int i;
    for (i=0; i<n; i++)
    {
      int j;
      for (j=0; j<n; j++)
        b[i+np*j] = ran2(1);
      y[i] = ran2(1);
    }

    int loop = 0;
    double dt = 0;
    double t0 = cptime();
    while (dt < tmin)
    {
      loop++;
      int i;
      for (i=0; i<n; i++)
      {
        int j;
        for (j=0; j<n; j++)
          a[i+np*j] = b[i+np*j];
        x[i] = y[i];
      }
      double d;
      int ier = ludcmp(a,n,np,indx,&d,v);
      if (ier != 0)
      {
        printf("MATRIX SINGULAR IN TSTSOL\n");
        printf("PROGAM ENDS HERE\n");
        exit(1);
      }
      lubksb(a,n,np,indx,x);
      for (i=0; i<n; i++)
      {
        double s=0;
        int j;
        for (j=0; j<n; j++)
          s += b[i+np*j]*x[j];
        if (fabs(s-y[i]) > 0.01*n)
        {
          printf("INCORRECT SOLUTION IN TSTSOL\n");
          printf("PROGAM ENDS HERE\n");
          exit(1);
        }
      }

      double t = cptime();
      dt = t - t0 - loop*tcp;
    }
    return dt/loop;
  }

  int ludcmp(double *a, int n, int np, int *indx,
                           double *d, double *vv)
  {
    const double tiny = 1.0e-20;
    d[0] = 1;

    int ier = 0;
    int imax = -1;
    double aamax;
    int i;

    for (i=0; i<n; i++)
    {
      int j;
      aamax = 0.0;
      for (j =0; j<n; j++)
        if (fabs(a[i+np*j]) > aamax)
          aamax = fabs(a[i+np*j]);
      if (aamax == 0.0)
      {
        ier = 1;
        d[0] = 0;
        return ier;
      }
      vv[i] = 1.0/aamax;
    }
    int j;
    for (j=0; j<n; j++)
    {
      if (j > 0)
      {
        int i;
        for (i=0; i<j; i++)
        {
          double sum = a[i+np*j];
          if (i > 0) 
          {
            int k;
            for (k=0; k<i; k++)
              sum -= a[i+np*k]*a[k+np*j];
            a[i+np*j] = sum;
          }
        }
      }
      aamax = 0;
      int i;
      for (i=j; i<n; i++)
      {
        double sum = a[i+np*j];
        if ( j > 0)
        {
          int k;
          for (k=0; k<j; k++)
            sum -= a[i+np*k]*a[k+np*j];
          a[i+np*j] = sum;
        }
        double dum = vv[i]*fabs(sum);
        if (dum > aamax)
        {
          imax = i;
          aamax = dum;
        }
      }
      if (j != imax)
      {
        int k;
        for (k=0; k<n; k++)
        {
          double dum = a[imax+np*k];
          a[imax+np*k] = a[j+np*k];
          a[j+np*k] = dum;
        }
        d[0] = -d[0];
        vv[imax] = vv[j];
      }
      indx[j] = imax;
      if ( j != n-1 )
      {
        if (a[j+np*j] == 0)
        {
          a[j+np*j] = tiny;
          ier = 2;
        }
        double dum = 1.0/a[j+np*j];
        int i;
        for (i=j+1; i<n; i++)
          a[i+np*j] = a[i+np*j]*dum;
      }
    }
    if (a[n-1+np*(n-1)] == 0)
      a[n-1+np*(n-1)] = tiny;
    return ier;
  }

  void lubksb(double *a, int n, int np, int *indx, 
                           double *b)
  {
    int ii=-1;
    int i;
    for (i=0; i<n; i++)
    {
      int ll = indx[i];
      double sum = b[ll];
      b[ll] = b[i];
      if (ii != -1)
      {
        int j;
        for (j=ii; j<i; j++)
          sum -= a[i+np*j]*b[j];
      }
      else
      {
        if (sum != 0.0)
          ii = i;
      }
      b[i] = sum;
    }
    for (i=n-1; i>=0; i--)
    {
      double sum = b[i];
      if ( i < n-1)
      {
        int j;
        for (j=i+1; j<n; j++)
          sum -= a[i+np*j]*b[j];
      }
      b[i] = sum/a[i+np*i];
    }
    return;
  }

  double tstsor(double *a, int n, double tcp, double tmin)
  {
    int i;
    for (i=0; i<n; i++)
      a[i] = ran2(1);

    sort(a,n);
    double t;
    int loop = 0;
    double t0 = cptime();

    double dt = 0;

    while (dt < tmin)
    {
      loop++;
      sort(a,n);

      t = cptime();
      dt=t - t0 -loop*tcp;
    }
    t = dt/loop;

    int lll=1;

    for (i=0; i<n-1; i++)
      lll = lll && (a[i] <= a[i+1]);

    if (!lll)
    {
      printf("ARRAY NOT SORTED IN TSTSOR\n");
      printf("PROGRAM ENDS HERE\n");
      exit(1);
    }

    return t;
  }

  void sort1(double *ra, int n)
  {
    int l=n/2+1;
    int ir = n;
    double rra;

    while (1)
    {
      if ( l > 1 )
      {
        l--;
        rra=ra[l-1];
      }
      else
      {
        rra = ra[ir-1];
        ra[ir-1] = ra[0];
        ir--;
        if(ir == 1)
        {
          ra[0] = rra;
          return;
        }
      }
      int i = l;
      int j = l+l;
      while(j <= ir)
      {
        if (j < ir)
          if (ra[j-1] < ra[j])
            j++;
        if(rra < ra[j-1])
        {
          ra[i-1] = ra[j-1];
          i = j;
          j = j+j;
        }
        else
          j = ir+1;
      }
      ra[i-1] = rra;
    }
  }
  void sort(double *ra, int n)
  {
    int l=n/2;
    int ir = n-1;
    double rra;

    while (1)
    {
      if ( l > 0 )
      {
        l--;
        rra=ra[l];
      }
      else
      {
        rra = ra[ir];
        ra[ir] = ra[0];
        ir--;
        if(ir == 0)
        {
          ra[0] = rra;
          return;
        }
      }
      int i = l;
      int j = l+l+1;
      while(j <= ir)
      {
        if (j < ir)
          if (ra[j] < ra[j+1])
            j++;
        if(rra < ra[j])
        {
          ra[i] = ra[j];
          i = j;
          j = j+j+1;
        }
        else
          j = ir+1;
      }
      ra[i] = rra;
    }
  }

  double dettmi()
  {
    double t0 = cptime();

    int m = 10;
    double p = 100.0;
    double dt = 0;

    double t = t0;
    int i;
    for (i=0; i<m; i++)
    {
      while (t == t0)
        t = cptime();
      dt += t - t0;
      t0 = t;
    }

    double tmin = p*dt/m;

    if(tmin > 100.0) 
    {
      printf("MINIMUM TIME FOR MEASUREMENTS GREATER THAN 100 SEC\n");
      printf("SOMETHING IS PROBABLY WRONG, PROGRAM STOPS\n");
      exit(1);
    }
    return tmin;
  }
  double cptime()
  {
    return cputime();
  }
  double meatcp(double tmin)
  {
    int loop = 0;
    double t0 = cptime();
    double tcp = loop*t0;

    double dt = 0;
    while (dt < tmin)
    {
      loop++;
      double t = cptime();
      dt = t - t0 - loop*tcp;
    }
    tcp = tmin/loop;
    return tcp;
  }

